Package org.flywaydb.core.api.configuration

## Class ClassicConfiguration

- java.lang.Object
- - org.flywaydb.core.api.configuration.ClassicConfiguration

- All Implemented Interfaces:
    `Configuration`

      public class ClassicConfiguration
      extends java.lang.Object
      implements Configuration

  JavaBean-style configuration for Flyway. This is primarily meant for compatibility with scenarios where the new FluentConfiguration isn't an easy fit, such as Spring XML bean configuration.

  This configuration can then be passed to Flyway using the `new Flyway(Configuration)` constructor.

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `ClassicConfiguration()` |
    `ClassicConfiguration​(java.lang.ClassLoader classLoader)` |
    `ClassicConfiguration​(Configuration configuration)` | Creates a new configuration with the same values as this existing one.
    `ClassicConfiguration​(org.flywaydb.core.internal.configuration.models.ConfigurationModel modernConfig)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `configure​(java.util.Map<java.lang.String,​java.lang.String> props)` | Configures Flyway with these properties.
    `void` | `configure​(java.util.Properties properties)` | Configures Flyway with these properties.
    `void` | `configure​(Configuration configuration)` | Configure with the same values as this existing configuration.
    `void` | `configureUsingEnvVars()` | Configures Flyway using FLYWAY_* environment variables.
    `java.lang.String` | `getBaselineDescription()` | Retrieves the description to tag an existing schema with when executing baseline.
    `MigrationVersion` | `getBaselineVersion()` | Retrieves the version to tag an existing schema with when executing baseline.
    `Callback[]` | `getCallbacks()` | Gets the callbacks for lifecycle notifications.
    `MigrationPattern[]` | `getCherryPick()` | Gets the migrations that Flyway should consider when migrating or undoing.
    `java.lang.ClassLoader` | `getClassLoader()` | Retrieves the ClassLoader to use for loading migrations, resolvers, etc.
    `int` | `getConnectRetries()` | The maximum number of retries when attempting to connect to the database.
    `int` | `getConnectRetriesInterval()` | The maximum time between retries when attempting to connect to the database in seconds.
    `javax.sql.DataSource` | `getDataSource()` | Retrieves the dataSource to use to access the database.
    `java.lang.String` | `getDefaultSchema()` | The default schema managed by Flyway.
    `java.lang.String` | `getDriver()` |
    `java.io.OutputStream` | `getDryRunOutput()` | The stream where to output the SQL statements of a migration dry run.
    `java.nio.charset.Charset` | `getEncoding()` | Retrieves the encoding of Sql migrations.
    `java.lang.String[]` | `getErrorOverrides()` | Rules for the built-in error handler that let you override specific SQL states and errors codes in order to force specific errors or warnings to be treated as debug messages, info messages, warnings or errors.
    `ValidatePattern[]` | `getIgnoreMigrationPatterns()` | Ignore migrations that match this comma-separated list of patterns when validating migrations.
    `java.lang.String` | `getInitSql()` | The SQL statements to run to initialize a new database connection immediately after opening it.
    `java.lang.String` | `getInstalledBy()` | The username that will be recorded in the schema history table as having applied the migration.
    `ClassProvider<JavaMigration>` | `getJavaMigrationClassProvider()` | Retrieves the custom ClassProvider to be used to look up `JavaMigration` classes.
    `JavaMigration[]` | `getJavaMigrations()` | The manually added Java-based migrations.
    `java.util.Map<java.lang.String,​java.lang.String>` | `getJdbcProperties()` | Properties to pass to the JDBC driver object Flyway Teams only
    `java.lang.String` | `getKerberosConfigFile()` | The path to the Kerberos config file.
    `java.lang.String` | `getLicenseKey()` | Your Flyway license key (FL01...).
    `Location[]` | `getLocations()` | Retrieves the locations to scan recursively for migrations.
    `int` | `getLockRetryCount()` | The maximum number of retries when trying to obtain a lock.
    `java.lang.String[]` | `getLoggers()` | The loggers Flyway should use.
    `org.flywaydb.core.internal.configuration.models.ConfigurationModel` | `getModernConfig()` |
    `java.lang.String` | `getOracleKerberosCacheFile()` |
    `java.lang.String` | `getOracleWalletLocation()` | The location of your Oracle wallet, used to automatically sign in to your databases.
    `java.lang.String` | `getPassword()` | Retrieves the password used to construct the dataSource.
    `java.lang.String` | `getPlaceholderPrefix()` | Retrieves the prefix of every placeholder.
    `java.util.Map<java.lang.String,​java.lang.String>` | `getPlaceholders()` | Retrieves the map of <placeholder, replacementValue> to apply to sql migration scripts.
    `java.lang.String` | `getPlaceholderSeparator()` | Retrieves the separator of default placeholders.
    `java.lang.String` | `getPlaceholderSuffix()` | Retrieves the suffix of every placeholder.
    `org.flywaydb.core.internal.plugin.PluginRegister` | `getPluginRegister()` |
    `java.lang.String` | `getRepeatableSqlMigrationPrefix()` | Retrieves the file name prefix for repeatable SQL migrations.
    `java.util.Map<java.lang.String,​org.flywaydb.core.internal.configuration.models.ResolvedEnvironment>` | `getResolvedEnvironments()` |
    `MigrationResolver[]` | `getResolvers()` | Retrieves the custom MigrationResolvers to be used in addition to the built-in ones for resolving Migrations to apply.
    `ResourceProvider` | `getResourceProvider()` | Retrieves the custom ResourceProvider to be used to look up resources.
    `java.lang.String[]` | `getSchemas()` | The schemas managed by Flyway.
    `java.lang.String` | `getScriptPlaceholderPrefix()` | Retrieves the prefix of every script placeholder.
    `java.lang.String` | `getScriptPlaceholderSuffix()` | Retrieves the suffix of every script placeholder.
    `java.lang.String` | `getSqlMigrationPrefix()` | The file name prefix for versioned SQL migrations.
    `java.lang.String` | `getSqlMigrationSeparator()` | Retrieves the file name separator for sql migrations.
    `java.lang.String[]` | `getSqlMigrationSuffixes()` | The file name suffixes for SQL migrations.
    `java.lang.String` | `getTable()` | Retrieves the name of the schema history table that will be used by Flyway.
    `java.lang.String` | `getTablespace()` | The tablespace where to create the schema history table that will be used by Flyway.
    `MigrationVersion` | `getTarget()` | Gets the target version up to which Flyway should consider migrations.
    `java.lang.String` | `getUndoSqlMigrationPrefix()` | The file name prefix for undo SQL migrations.
    `java.lang.String` | `getUrl()` | Retrieves the url used to construct the dataSource.
    `java.lang.String` | `getUser()` | Retrieves the user used to construct the dataSource.
    `boolean` | `isBaselineOnMigrate()` | Whether to automatically call baseline when migrate is executed against a non-empty schema with no schema history table.
    `boolean` | `isBatch()` | Whether to batch SQL statements when executing them.
    `boolean` | `isCleanDisabled()` | Whether to disable clean.
    `boolean` | `isCleanOnValidationError()` | Whether to automatically call clean or not when a validation error occurs.
    `boolean` | `isCreateSchemas()` | Whether Flyway should attempt to create the schemas specified in the schemas property.
    `boolean` | `isDetectEncoding()` | Whether Flyway should try to automatically detect SQL migration file encoding
    `boolean` | `isExecuteInTransaction()` | Checks whether SQL is executed in a transaction.
    `boolean` | `isFailOnMissingLocations()` | Whether to fail if a location specified in the flyway.locations option doesn't exist
    `boolean` | `isFailOnMissingTarget()` | Whether to fail if no migration with the configured target version exists (default: `true`)
    `boolean` | `isGroup()` | Whether to group all pending migrations together in the same transaction when applying them (only recommended for databases with support for DDL transactions).
    `boolean` | `isMixed()` | Whether to allow mixing transactional and non-transactional statements within the same migration.
    `boolean` | `isOracleSqlplus()` | Whether to Flyway's support for Oracle SQL*Plus commands should be activated.
    `boolean` | `isOracleSqlplusWarn()` | Whether Flyway should issue a warning instead of an error whenever it encounters an Oracle SQL*Plus statement it doesn't yet support.
    `boolean` | `isOutOfOrder()` | Allows migrations to be run "out of order".
    `boolean` | `isOutputQueryResults()` | Whether Flyway should output a table with the results of queries when executing migrations.
    `boolean` | `isPlaceholderReplacement()` | Checks whether placeholders should be replaced.
    `boolean` | `isSkipDefaultCallbacks()` | Whether Flyway should skip the default callbacks.
    `boolean` | `isSkipDefaultResolvers()` | Whether Flyway should skip the default resolvers.
    `boolean` | `isSkipExecutingMigrations()` | Whether Flyway should skip actually executing the contents of the migrations and only update the schema history table.
    `boolean` | `isStream()` | Whether to stream SQL migrations when executing them.
    `boolean` | `isValidateMigrationNaming()` | Whether to validate migrations and callbacks whose scripts do not obey the correct naming convention.
    `boolean` | `isValidateOnMigrate()` | Whether to automatically call validate or not when running migrate.
    `java.util.List<Callback>` | `loadCallbackLocation​(java.lang.String path, boolean errorOnNotFound)` | Scan this location for classes that implement Callback.
    `void` | `setBaselineDescription​(java.lang.String baselineDescriptionProp)` |
    `void` | `setBaselineOnMigrate​(java.lang.Boolean baselineOnMigrateProp)` |
    `void` | `setBaselineVersion​(java.lang.String baselineVersionProp)` |
    `void` | `setBaselineVersionAsString​(java.lang.String baselineVersion)` | Sets the version to tag an existing schema with when executing baseline.
    `void` | `setBatch​(boolean batch)` | Whether to batch SQL statements when executing them.
    `void` | `setCallbacks​(Callback... callbacks)` |
    `void` | `setCallbacksAsClassNames​(java.lang.String... callbacks)` | Set the callbacks for lifecycle notifications.
    `void` | `setCherryPick​(java.lang.String... cherryPickAsString)` | Gets the migrations that Flyway should consider when migrating or undoing.
    `void` | `setCherryPick​(MigrationPattern... cherryPick)` | Gets the migrations that Flyway should consider when migrating or undoing.
    `void` | `setClassLoader​(java.lang.ClassLoader classLoader)` |
    `void` | `setCleanDisabled​(java.lang.Boolean cleanDisabledProp)` |
    `void` | `setCleanOnValidationError​(java.lang.Boolean cleanOnValidationErrorProp)` |
    `void` | `setConnectRetries​(int connectRetries)` | The maximum number of retries when attempting to connect to the database.
    `void` | `setConnectRetriesInterval​(int connectRetriesInterval)` | The maximum time between retries when attempting to connect to the database in seconds.
    `void` | `setDataSource​(java.lang.String url, java.lang.String user, java.lang.String password)` | Sets the datasource to use.
    `void` | `setDataSource​(javax.sql.DataSource dataSource)` | Sets the datasource to use.
    `void` | `setDefaultSchema​(java.lang.String defaultSchema)` |
    `void` | `setDetectEncoding​(boolean detectEncoding)` | Whether Flyway should try to automatically detect SQL migration file encoding
    `void` | `setDriver​(java.lang.String driver)` |
    `void` | `setDryRunOutput​(java.io.OutputStream dryRunOutput)` | Sets the stream where to output the SQL statements of a migration dry run.
    `void` | `setDryRunOutputAsFile​(java.io.File dryRunOutput)` | Sets the file where to output the SQL statements of a migration dry run.
    `void` | `setDryRunOutputAsFileName​(java.lang.String dryRunOutputFileName)` | Sets the file where to output the SQL statements of a migration dry run.
    `void` | `setEncoding​(java.nio.charset.Charset encoding)` |
    `void` | `setEncodingAsString​(java.lang.String encoding)` | Sets the encoding of SQL migrations.
    `void` | `setErrorOverrides​(java.lang.String... errorOverrides)` | Rules for the built-in error handler that let you override specific SQL states and errors codes in order to force specific errors or warnings to be treated as debug messages, info messages, warnings or errors.
    `void` | `setExecuteInTransaction​(boolean executeInTransaction)` | Sets whether SQL should be executed within a transaction.
    `void` | `setFailOnMissingLocations​(java.lang.Boolean failOnMissingLocationsProp)` |
    `void` | `setGroup​(java.lang.Boolean groupProp)` |
    `void` | `setIgnoreMigrationPatterns​(java.lang.String... ignoreMigrationPatterns)` | Ignore migrations that match this comma-separated list of patterns when validating migrations.
    `void` | `setIgnoreMigrationPatterns​(ValidatePattern... ignoreMigrationPatterns)` | Ignore migrations that match this array of ValidatePatterns when validating migrations.
    `void` | `setInitSql​(java.lang.String initSqlProp)` |
    `void` | `setInstalledBy​(java.lang.String installedBy)` | The username that will be recorded in the schema history table as having applied the migration.
    `void` | `setJavaMigrationClassProvider​(ClassProvider<JavaMigration> javaMigrationClassProvider)` |
    `void` | `setJavaMigrations​(JavaMigration... javaMigrations)` | The manually added Java-based migrations.
    `void` | `setJdbcProperties​(java.util.Map<java.lang.String,​java.lang.String> jdbcProperties)` | Properties to pass to the JDBC driver object.
    `void` | `setKerberosConfigFile​(java.lang.String kerberosConfigFile)` | When connecting to a Kerberos service to authenticate, the path to the Kerberos config file.
    `void` | `setLicenseKey​(java.lang.String licenseKey)` | Your Flyway license key (FL01...).
    `void` | `setLocations​(Location... locations)` | Sets the locations to scan recursively for migrations.
    `void` | `setLocationsAsStrings​(java.lang.String... locations)` | Sets the locations to scan recursively for migrations.
    `void` | `setLockRetryCount​(java.lang.Integer lockRetryCount)` |
    `void` | `setLoggers​(java.lang.String... loggers)` | The loggers Flyway should use.
    `void` | `setMixed​(java.lang.Boolean mixedProp)` |
    `void` | `setModernConfig​(org.flywaydb.core.internal.configuration.models.ConfigurationModel modernConfig)` |
    `void` | `setOracleKerberosCacheFile​(java.lang.String oracleKerberosCacheFile)` | When Oracle needs to connect to a Kerberos service to authenticate, the location of the Kerberos cache.
    `void` | `setOracleSqlplus​(boolean oracleSqlplus)` | Whether Flyway's support for Oracle SQL*Plus commands should be activated.
    `void` | `setOracleSqlplusWarn​(boolean oracleSqlplusWarn)` | Whether Flyway should issue a warning instead of an error whenever it encounters an Oracle SQL*Plus statementit doesn't yet support.
    `void` | `setOracleWalletLocation​(java.lang.String oracleWalletLocation)` | The location of your Oracle wallet, used to automatically sign in to your databases.
    `void` | `setOutOfOrder​(java.lang.Boolean outOfOrderProp)` |
    `void` | `setOutputQueryResults​(boolean outputQueryResults)` | Whether Flyway should output a table with the results of queries when executing migrations.
    `void` | `setPassword​(java.lang.String password)` |
    `void` | `setPlaceholderPrefix​(java.lang.String placeholderPrefix)` | Sets the prefix of every placeholder.
    `void` | `setPlaceholderReplacement​(java.lang.Boolean placeholderReplacementProp)` |
    `void` | `setPlaceholders​(java.util.Map<java.lang.String,​java.lang.String> placeholdersFromProps)` |
    `void` | `setPlaceholderSeparator​(java.lang.String placeholderSeparator)` | Sets the separator of default placeholders.
    `void` | `setPlaceholderSuffix​(java.lang.String placeholderSuffix)` | Sets the suffix of every placeholder.
    `void` | `setPluginRegister​(org.flywaydb.core.internal.plugin.PluginRegister pluginRegister)` |
    `void` | `setRepeatableSqlMigrationPrefix​(java.lang.String repeatableSqlMigrationPrefixProp)` |
    `void` | `setResolvers​(MigrationResolver... resolvers)` | Sets custom MigrationResolvers to be used in addition to the built-in ones for resolving Migrations to apply.
    `void` | `setResolversAsClassNames​(java.lang.String... resolvers)` | Sets custom MigrationResolvers to be used in addition to the built-in ones for resolving Migrations to apply.
    `void` | `setResourceProvider​(ResourceProvider resourceProvider)` |
    `void` | `setSchemas​(java.lang.String[] tokenizeToStringArray)` |
    `void` | `setScriptPlaceholderPrefix​(java.lang.String scriptPlaceholderPrefix)` | Sets the prefix of every script placeholder.
    `void` | `setScriptPlaceholderSuffix​(java.lang.String scriptPlaceholderSuffix)` | Sets the suffix of every placeholder.
    `void` | `setShouldCreateSchemas​(boolean createSchemas)` | Whether Flyway should attempt to create the schemas specified in the schemas property.
    `void` | `setSkipDefaultCallbacks​(java.lang.Boolean skipDefaultCallbacksProp)` |
    `void` | `setSkipDefaultResolvers​(java.lang.Boolean skipDefaultResolversProp)` |
    `void` | `setSkipExecutingMigrations​(boolean skipExecutingMigrations)` | Whether Flyway should skip actually executing the contents of the migrations and only update the schema history table.
    `void` | `setSqlMigrationPrefix​(java.lang.String sqlMigrationPrefix)` | Sets the file name prefix for sql migrations.
    `void` | `setSqlMigrationSeparator​(java.lang.String sqlMigrationSeparator)` | Sets the file name separator for sql migrations.
    `void` | `setSqlMigrationSuffixes​(java.lang.String... sqlMigrationSuffixes)` | The file name suffixes for SQL migrations.
    `void` | `setStream​(boolean stream)` | Whether to stream SQL migrations when executing them.
    `void` | `setTable​(java.lang.String tableProp)` |
    `void` | `setTablespace​(java.lang.String tablespaceProp)` |
    `void` | `setTarget​(MigrationVersion target)` |
    `void` | `setTargetAsString​(java.lang.String target)` | Sets the target version up to which Flyway should consider migrations.
    `void` | `setUndoSqlMigrationPrefix​(java.lang.String undoSqlMigrationPrefix)` | Sets the file name prefix for undo SQL migrations.
    `void` | `setUrl​(java.lang.String url)` |
    `void` | `setUser​(java.lang.String user)` |
    `void` | `setValidateMigrationNaming​(java.lang.Boolean validateMigrationNamingProp)` |
    `void` | `setValidateOnMigrate​(java.lang.Boolean validateOnMigrateProp)` |

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### ClassicConfiguration

          public ClassicConfiguration​(org.flywaydb.core.internal.configuration.models.ConfigurationModel modernConfig)

    - #### ClassicConfiguration

          public ClassicConfiguration()

    - #### ClassicConfiguration

          public ClassicConfiguration​(java.lang.ClassLoader classLoader)

      Parameters:
        `classLoader` - The ClassLoader to use for loading migrations, resolvers, etc. from the classpath. (default: Thread.currentThread().getContextClassLoader())

    - #### ClassicConfiguration

          public ClassicConfiguration​(Configuration configuration)

      Creates a new configuration with the same values as this existing one.

  - ### Method Detail

    - #### setDefaultSchema

          public void setDefaultSchema​(java.lang.String defaultSchema)

    - #### getDefaultSchema

          public java.lang.String getDefaultSchema()

      Description copied from interface: `Configuration`
      The default schema managed by Flyway. This schema name is case-sensitive. If not specified, but schemas is, Flyway uses the first schema in that list. If that is also not specified, Flyway uses the default schema for the database connection.

      Consequences:

      - This schema will be the one containing the schema history table.
      - This schema will be the default for the database connection (provided the database supports this concept).
      Specified by:
        `getDefaultSchema` in interface `Configuration`
      Returns:
        The default schema managed by Flyway, which is where the schema history table will reside. (default: The first schema specified in getSchemas(), and failing that the default schema for the database connection)

    - #### getSchemas

          public java.lang.String[] getSchemas()

      Description copied from interface: `Configuration`
      The schemas managed by Flyway. These schema names are case-sensitive. If not specified, Flyway uses the default schema for the database connection. If defaultSchema is not specified, then the first of this list also acts as the default schema.

      Consequences:

      - Flyway will automatically attempt to create all these schemas, unless they already exist.
      - The schemas will be cleaned in the order of this list.
      - If Flyway created them, the schemas themselves will be dropped when cleaning.
      Specified by:
        `getSchemas` in interface `Configuration`
      Returns:
        The schemas managed by Flyway. (default: The default schema for the database connection)

    - #### getEncoding

          public java.nio.charset.Charset getEncoding()

      Description copied from interface: `Configuration`
      Retrieves the encoding of Sql migrations.
      Specified by:
        `getEncoding` in interface `Configuration`
      Returns:
        The encoding of Sql migrations. (default: UTF-8)

    - #### isDetectEncoding

          public boolean isDetectEncoding()

      Description copied from interface: `Configuration`
      Whether Flyway should try to automatically detect SQL migration file encoding
      Specified by:
        `isDetectEncoding` in interface `Configuration`
      Returns:
        `true` to enable auto detection, `false` otherwise Flyway Teams only

    - #### getCallbacks

          public Callback[] getCallbacks()

      Description copied from interface: `Configuration`
      Gets the callbacks for lifecycle notifications.
      Specified by:
        `getCallbacks` in interface `Configuration`
      Returns:
        The callbacks for lifecycle notifications. An empty array if none. (default: none)

    - #### getUrl

          public java.lang.String getUrl()

      Description copied from interface: `Configuration`
      Retrieves the url used to construct the dataSource. May be null if the dataSource was passed in directly.
      Specified by:
        `getUrl` in interface `Configuration`
      Returns:
        The url used to construct the dataSource. May be null if the dataSource was passed in directly.

    - #### getUser

          public java.lang.String getUser()

      Description copied from interface: `Configuration`
      Retrieves the user used to construct the dataSource. May be null if the dataSource was passed in directly, or if dataSource did not need a user.
      Specified by:
        `getUser` in interface `Configuration`
      Returns:
        The user used to construct the dataSource. May be null if the dataSource was passed in directly, or if dataSource did not need a user.

    - #### getPassword

          public java.lang.String getPassword()

      Description copied from interface: `Configuration`
      Retrieves the password used to construct the dataSource. May be null if the dataSource was passed in directly, or if dataSource did not need a password.
      Specified by:
        `getPassword` in interface `Configuration`
      Returns:
        The password used to construct the dataSource. May be null if the dataSource was passed in directly, or if dataSource did not need a password.

    - #### getLocations

          public Location[] getLocations()

      Description copied from interface: `Configuration`
      Retrieves the locations to scan recursively for migrations. The location type is determined by its prefix. Unprefixed locations or locations starting with `classpath:` point to a package on the classpath and may contain both SQL and Java-based migrations. Locations starting with `filesystem:` point to a directory on the filesystem, may only contain SQL migrations and are only scanned recursively down non-hidden directories.
      Specified by:
        `getLocations` in interface `Configuration`
      Returns:
        Locations to scan recursively for migrations. (default: classpath:db/migration)

    - #### isBaselineOnMigrate

          public boolean isBaselineOnMigrate()

      Description copied from interface: `Configuration`
      Whether to automatically call baseline when migrate is executed against a non-empty schema with no schema history table. This schema will then be initialized with the `baselineVersion` before executing the migrations. Only migrations above `baselineVersion` will then be applied. This is useful for initial Flyway production deployments on projects with an existing DB. Be careful when enabling this as it removes the safety net that ensures Flyway does not migrate the wrong database in case of a configuration mistake!
      Specified by:
        `isBaselineOnMigrate` in interface `Configuration`
      Returns:
        `true` if baseline should be called on migrate for non-empty schemas, `false` if not. (default: `false`)

    - #### isSkipExecutingMigrations

          public boolean isSkipExecutingMigrations()

      Description copied from interface: `Configuration`
      Whether Flyway should skip actually executing the contents of the migrations and only update the schema history table. This should be used when you have applied a migration manually (via executing the sql yourself, or via an ide), and just want the schema history table to reflect this. Use in conjunction with `cherryPick` to skip specific migrations instead of all pending ones. Flyway Teams only
      Specified by:
        `isSkipExecutingMigrations` in interface `Configuration`
      Returns:
        `true` if executing the migrations should be skipped on migrate, `false` if not. (default: `false`)

    - #### isOutOfOrder

          public boolean isOutOfOrder()

      Description copied from interface: `Configuration`
      Allows migrations to be run "out of order". If you already have versions 1 and 3 applied, and now a version 2 is found, it will be applied too instead of being ignored.
      Specified by:
        `isOutOfOrder` in interface `Configuration`
      Returns:
        `true` if outOfOrder migrations should be applied, `false` if not. (default: `false`)

    - #### getIgnoreMigrationPatterns

          public ValidatePattern[] getIgnoreMigrationPatterns()

      Description copied from interface: `Configuration`
      Ignore migrations that match this comma-separated list of patterns when validating migrations. Each pattern is of the form : See https://flywaydb.org/documentation/configuration/parameters/ignoreMigrationPatterns for full details Example: repeatable:missing,versioned:pending,*:failed (default: *:future) Flyway Teams only
      Specified by:
        `getIgnoreMigrationPatterns` in interface `Configuration`

    - #### isValidateMigrationNaming

          public boolean isValidateMigrationNaming()

      Description copied from interface: `Configuration`
      Whether to validate migrations and callbacks whose scripts do not obey the correct naming convention. A failure can be useful to check that errors such as case sensitivity in migration prefixes have been corrected.
      Specified by:
        `isValidateMigrationNaming` in interface `Configuration`
      Returns:
        `false` to continue normally, `true` to fail fast with an exception. (default: `false`)

    - #### isValidateOnMigrate

          public boolean isValidateOnMigrate()

      Description copied from interface: `Configuration`
      Whether to automatically call validate or not when running migrate.
      Specified by:
        `isValidateOnMigrate` in interface `Configuration`
      Returns:
        `true` if validate should be called. `false` if not. (default: `true`)

    - #### isCleanOnValidationError

          public boolean isCleanOnValidationError()

      Description copied from interface: `Configuration`
      Whether to automatically call clean or not when a validation error occurs. This is exclusively intended as a convenience for development. even though we strongly recommend not to change migration scripts once they have been checked into SCM and run, this provides a way of dealing with this case in a smooth manner. The database will be wiped clean automatically, ensuring that the next migration will bring you back to the state checked into SCM. Warning! Do not enable in production!
      Specified by:
        `isCleanOnValidationError` in interface `Configuration`
      Returns:
        `true` if clean should be called. `false` if not. (default: `false`)

    - #### isCleanDisabled

          public boolean isCleanDisabled()

      Description copied from interface: `Configuration`
      Whether to disable clean. This is especially useful for production environments where running clean can be a career limiting move.
      Specified by:
        `isCleanDisabled` in interface `Configuration`
      Returns:
        `true` to disable clean. `false` to be able to clean. (default: `true`)

    - #### isMixed

          public boolean isMixed()

      Description copied from interface: `Configuration`
      Whether to allow mixing transactional and non-transactional statements within the same migration. Enabling this automatically causes the entire affected migration to be run without a transaction. Note that this is only applicable for PostgreSQL, Aurora PostgreSQL, SQL Server and SQLite which all have statements that do not run at all within a transaction. This is not to be confused with implicit transaction, as they occur in MySQL or Oracle, where even though a DDL statement was run within a transaction, the database will issue an implicit commit before and after its execution.
      Specified by:
        `isMixed` in interface `Configuration`
      Returns:
        `true` if mixed migrations should be allowed. `false` if an error should be thrown instead. (default: `false`)

    - #### isGroup

          public boolean isGroup()

      Description copied from interface: `Configuration`
      Whether to group all pending migrations together in the same transaction when applying them (only recommended for databases with support for DDL transactions).
      Specified by:
        `isGroup` in interface `Configuration`
      Returns:
        `true` if migrations should be grouped. `false` if they should be applied individually instead. (default: `false`)

    - #### getInstalledBy

          public java.lang.String getInstalledBy()

      Description copied from interface: `Configuration`
      The username that will be recorded in the schema history table as having applied the migration.
      Specified by:
        `getInstalledBy` in interface `Configuration`
      Returns:
        The username or `null` for the current database user of the connection. (default: `null`).

    - #### getErrorOverrides

          public java.lang.String[] getErrorOverrides()

      Description copied from interface: `Configuration`
      Rules for the built-in error handler that let you override specific SQL states and errors codes in order to force specific errors or warnings to be treated as debug messages, info messages, warnings or errors.

      Each error override has the following format: `STATE:12345:W`. It is a 5 character SQL state (or * to match all SQL states), a colon, the SQL error code (or * to match all SQL error codes), a colon and finally the desired behavior that should override the initial one.

      The following behaviors are accepted:

      - `D` to force a debug message
      - `D-` to force a debug message, but do not show the original sql state and error code
      - `I` to force an info message
      - `I-` to force an info message, but do not show the original sql state and error code
      - `W` to force a warning
      - `W-` to force a warning, but do not show the original sql state and error code
      - `E` to force an error
      - `E-` to force an error, but do not show the original sql state and error code

      Example 1: to force Oracle stored procedure compilation issues to produce errors instead of warnings, the following errorOverride can be used: `99999:17110:E`

      Example 2: to force SQL Server PRINT messages to be displayed as info messages (without SQL state and error code details) instead of warnings, the following errorOverride can be used: `S0001:0:I-`

      Example 3: to force all errors with SQL error code 123 to be treated as warnings instead, the following errorOverride can be used: `*:123:W`

      Flyway Teams only
      Specified by:
        `getErrorOverrides` in interface `Configuration`
      Returns:
        The ErrorOverrides or an empty array if none are defined. (default: none)

    - #### getDryRunOutput

          public java.io.OutputStream getDryRunOutput()

      Description copied from interface: `Configuration`
      The stream where to output the SQL statements of a migration dry run. `null` if the SQL statements are executed against the database directly. Flyway Teams only
      Specified by:
        `getDryRunOutput` in interface `Configuration`
      Returns:
        The stream or `null` if the SQL statements are executed against the database directly.

    - #### isStream

          public boolean isStream()

      Description copied from interface: `Configuration`
      Whether to stream SQL migrations when executing them. Streaming doesn't load the entire migration in memory at once. Instead each statement is loaded individually. This is particularly useful for very large SQL migrations composed of multiple MB or even GB of reference data, as this dramatically reduces Flyway's memory consumption. Flyway Teams only
      Specified by:
        `isStream` in interface `Configuration`
      Returns:
        `true` to stream SQL migrations. `false` to fully loaded them in memory instead. (default: `false`)

    - #### isBatch

          public boolean isBatch()

      Description copied from interface: `Configuration`
      Whether to batch SQL statements when executing them. Batching can save up to 99 percent of network roundtrips by sending up to 100 statements at once over the network to the database, instead of sending each statement individually. This is particularly useful for very large SQL migrations composed of multiple MB or even GB of reference data, as this can dramatically reduce the network overhead. This is supported for INSERT, UPDATE, DELETE, MERGE and UPSERT statements. All other statements are automatically executed without batching. Flyway Teams only
      Specified by:
        `isBatch` in interface `Configuration`
      Returns:
        `true` to batch SQL statements. `false` to execute them individually instead. (default: `false`)

    - #### isOracleSqlplus

          public boolean isOracleSqlplus()

      Description copied from interface: `Configuration`
      Whether to Flyway's support for Oracle SQL*Plus commands should be activated. Flyway Teams only
      Specified by:
        `isOracleSqlplus` in interface `Configuration`
      Returns:
        `true` to active SQL*Plus support. `false` to fail fast instead. (default: `false`)

    - #### isOracleSqlplusWarn

          public boolean isOracleSqlplusWarn()

      Description copied from interface: `Configuration`
      Whether Flyway should issue a warning instead of an error whenever it encounters an Oracle SQL*Plus statement it doesn't yet support. Flyway Teams only
      Specified by:
        `isOracleSqlplusWarn` in interface `Configuration`
      Returns:
        `true` to issue a warning. `false` to fail fast instead. (default: `false`)

    - #### getKerberosConfigFile

          public java.lang.String getKerberosConfigFile()

      Description copied from interface: `Configuration`
      The path to the Kerberos config file. Flyway Teams only
      Specified by:
        `getKerberosConfigFile` in interface `Configuration`

    - #### getOracleKerberosCacheFile

          public java.lang.String getOracleKerberosCacheFile()

      Specified by:
        `getOracleKerberosCacheFile` in interface `Configuration`

    - #### getLicenseKey

          public java.lang.String getLicenseKey()

      Description copied from interface: `Configuration`
      Your Flyway license key (FL01...). Not yet a Flyway Teams Edition customer? Request your Flyway trial license key to try out Flyway Teams Edition features free for 30 days. Flyway Teams only
      Specified by:
        `getLicenseKey` in interface `Configuration`
      Returns:
        Your Flyway license key.

    - #### isOutputQueryResults

          public boolean isOutputQueryResults()

      Description copied from interface: `Configuration`
      Whether Flyway should output a table with the results of queries when executing migrations. Flyway Teams only
      Specified by:
        `isOutputQueryResults` in interface `Configuration`
      Returns:
        `true` to output the results table (default: `true`)

    - #### isCreateSchemas

          public boolean isCreateSchemas()

      Description copied from interface: `Configuration`
      Whether Flyway should attempt to create the schemas specified in the schemas property.
      Specified by:
        `isCreateSchemas` in interface `Configuration`
      Returns:

    - #### getLockRetryCount

          public int getLockRetryCount()

      Description copied from interface: `Configuration`
      The maximum number of retries when trying to obtain a lock. -1 indicates attempting to repeat indefinitely.
      Specified by:
        `getLockRetryCount` in interface `Configuration`

    - #### getJdbcProperties

          public java.util.Map<java.lang.String,​java.lang.String> getJdbcProperties()

      Description copied from interface: `Configuration`
      Properties to pass to the JDBC driver object Flyway Teams only
      Specified by:
        `getJdbcProperties` in interface `Configuration`
      Returns:
        Properties that will be passed to the JDBC driver object

    - #### isFailOnMissingLocations

          public boolean isFailOnMissingLocations()

      Description copied from interface: `Configuration`
      Whether to fail if a location specified in the flyway.locations option doesn't exist
      Specified by:
        `isFailOnMissingLocations` in interface `Configuration`
      Returns:

    - #### getOracleWalletLocation

          public java.lang.String getOracleWalletLocation()

      Description copied from interface: `Configuration`
      The location of your Oracle wallet, used to automatically sign in to your databases. Flyway Teams only
      Specified by:
        `getOracleWalletLocation` in interface `Configuration`

    - #### getLoggers

          public java.lang.String[] getLoggers()

      Description copied from interface: `Configuration`
      The loggers Flyway should use. Valid options are:
      - auto: Auto detect the logger (default behavior)
      - console: Use stdout/stderr (only available when using the CLI)
      - slf4j2: Use the slf4j2 logger
      - log4j2: Use the log4j2 logger
      - apache-commons: Use the Apache Commons logger
      Alternatively you can provide the fully qualified class name for any other logger to use that.
      Specified by:
        `getLoggers` in interface `Configuration`

    - #### getConnectRetries

          public int getConnectRetries()

      Description copied from interface: `Configuration`
      The maximum number of retries when attempting to connect to the database. After each failed attempt, Flyway will wait 1 second before attempting to connect again, up to the maximum number of times specified by connectRetries. The interval between retries doubles with each subsequent attempt.
      Specified by:
        `getConnectRetries` in interface `Configuration`
      Returns:
        The maximum number of retries when attempting to connect to the database. (default: 0)

    - #### getConnectRetriesInterval

          public int getConnectRetriesInterval()

      Description copied from interface: `Configuration`
      The maximum time between retries when attempting to connect to the database in seconds. This will cap the interval between connect retry to the value provided.
      Specified by:
        `getConnectRetriesInterval` in interface `Configuration`
      Returns:
        The maximum time between retries in seconds (default: 120)

    - #### getInitSql

          public java.lang.String getInitSql()

      Description copied from interface: `Configuration`
      The SQL statements to run to initialize a new database connection immediately after opening it.
      Specified by:
        `getInitSql` in interface `Configuration`
      Returns:
        The SQL statements. (default: `null`)

    - #### getBaselineVersion

          public MigrationVersion getBaselineVersion()

      Description copied from interface: `Configuration`
      Retrieves the version to tag an existing schema with when executing baseline.
      Specified by:
        `getBaselineVersion` in interface `Configuration`
      Returns:
        The version to tag an existing schema with when executing baseline. (default: 1)

    - #### getBaselineDescription

          public java.lang.String getBaselineDescription()

      Description copied from interface: `Configuration`
      Retrieves the description to tag an existing schema with when executing baseline.
      Specified by:
        `getBaselineDescription` in interface `Configuration`
      Returns:
        The description to tag an existing schema with when executing baseline. (default: << Flyway Baseline >>)

    - #### getResolvers

          public MigrationResolver[] getResolvers()

      Description copied from interface: `Configuration`
      Retrieves the custom MigrationResolvers to be used in addition to the built-in ones for resolving Migrations to apply.
      Specified by:
        `getResolvers` in interface `Configuration`
      Returns:
        The custom MigrationResolvers to be used in addition to the built-in ones for resolving Migrations to apply. An empty array if none. (default: none)

    - #### isSkipDefaultResolvers

          public boolean isSkipDefaultResolvers()

      Description copied from interface: `Configuration`
      Whether Flyway should skip the default resolvers. If true, only custom resolvers are used.
      Specified by:
        `isSkipDefaultResolvers` in interface `Configuration`
      Returns:
        Whether default built-in resolvers should be skipped. (default: false)

    - #### isSkipDefaultCallbacks

          public boolean isSkipDefaultCallbacks()

      Description copied from interface: `Configuration`
      Whether Flyway should skip the default callbacks. If true, only custom callbacks are used.
      Specified by:
        `isSkipDefaultCallbacks` in interface `Configuration`
      Returns:
        Whether default built-in callbacks should be skipped. (default: false)

    - #### getSqlMigrationPrefix

          public java.lang.String getSqlMigrationPrefix()

      Description copied from interface: `Configuration`
      The file name prefix for versioned SQL migrations. Versioned SQL migrations have the following file name structure: prefixVERSIONseparatorDESCRIPTIONsuffix, which using the defaults translates to V1.1__My_description.sql
      Specified by:
        `getSqlMigrationPrefix` in interface `Configuration`
      Returns:
        The file name prefix for sql migrations. (default: V)

    - #### getUndoSqlMigrationPrefix

          public java.lang.String getUndoSqlMigrationPrefix()

      Description copied from interface: `Configuration`
      The file name prefix for undo SQL migrations. Undo SQL migrations are responsible for undoing the effects of the versioned migration with the same version. They have the following file name structure: prefixVERSIONseparatorDESCRIPTIONsuffix, which using the defaults translates to U1.1__My_description.sql Flyway Teams only
      Specified by:
        `getUndoSqlMigrationPrefix` in interface `Configuration`
      Returns:
        The file name prefix for undo sql migrations. (default: U)

    - #### isExecuteInTransaction

          public boolean isExecuteInTransaction()

      Description copied from interface: `Configuration`
      Checks whether SQL is executed in a transaction.
      Specified by:
        `isExecuteInTransaction` in interface `Configuration`
      Returns:
        Whether SQL is executed in a transaction. (default: true)

    - #### getRepeatableSqlMigrationPrefix

          public java.lang.String getRepeatableSqlMigrationPrefix()

      Description copied from interface: `Configuration`
      Retrieves the file name prefix for repeatable SQL migrations. Repeatable SQL migrations have the following file name structure: prefixSeparatorDESCRIPTIONsuffix, which using the defaults translates to R__My_description.sql<
      Specified by:
        `getRepeatableSqlMigrationPrefix` in interface `Configuration`
      Returns:
        The file name prefix for repeatable sql migrations. (default: R)

    - #### getSqlMigrationSeparator

          public java.lang.String getSqlMigrationSeparator()

      Description copied from interface: `Configuration`
      Retrieves the file name separator for sql migrations. SQL migrations have the following file name structure: prefixVERSIONseparatorDESCRIPTIONsuffix, which using the defaults translates to V1_1__My_description.sql
      Specified by:
        `getSqlMigrationSeparator` in interface `Configuration`
      Returns:
        The file name separator for sql migrations. (default: __)

    - #### getSqlMigrationSuffixes

          public java.lang.String[] getSqlMigrationSuffixes()

      Description copied from interface: `Configuration`
      The file name suffixes for SQL migrations. (default: .sql) SQL migrations have the following file name structure: prefixVERSIONseparatorDESCRIPTIONsuffix, which using the defaults translates to V1_1__My_description.sql Multiple suffixes (like .sql,.pkg,.pkb) can be specified for easier compatibility with other tools such as editors with specific file associations.
      Specified by:
        `getSqlMigrationSuffixes` in interface `Configuration`
      Returns:
        The file name suffixes for SQL migrations.

    - #### isPlaceholderReplacement

          public boolean isPlaceholderReplacement()

      Description copied from interface: `Configuration`
      Checks whether placeholders should be replaced.
      Specified by:
        `isPlaceholderReplacement` in interface `Configuration`
      Returns:
        Whether placeholders should be replaced. (default: true)

    - #### getPlaceholderSuffix

          public java.lang.String getPlaceholderSuffix()

      Description copied from interface: `Configuration`
      Retrieves the suffix of every placeholder.
      Specified by:
        `getPlaceholderSuffix` in interface `Configuration`
      Returns:
        The suffix of every placeholder. (default: } )

    - #### getPlaceholderPrefix

          public java.lang.String getPlaceholderPrefix()

      Description copied from interface: `Configuration`
      Retrieves the prefix of every placeholder.
      Specified by:
        `getPlaceholderPrefix` in interface `Configuration`
      Returns:
        The prefix of every placeholder. (default: ${ )

    - #### getPlaceholderSeparator

          public java.lang.String getPlaceholderSeparator()

      Description copied from interface: `Configuration`
      Retrieves the separator of default placeholders.
      Specified by:
        `getPlaceholderSeparator` in interface `Configuration`
      Returns:
        The separator of default placeholders. (default: : )

    - #### getScriptPlaceholderSuffix

          public java.lang.String getScriptPlaceholderSuffix()

      Description copied from interface: `Configuration`
      Retrieves the suffix of every script placeholder.
      Specified by:
        `getScriptPlaceholderSuffix` in interface `Configuration`
      Returns:
        The suffix of every script placeholder. (default: __ )

    - #### getScriptPlaceholderPrefix

          public java.lang.String getScriptPlaceholderPrefix()

      Description copied from interface: `Configuration`
      Retrieves the prefix of every script placeholder.
      Specified by:
        `getScriptPlaceholderPrefix` in interface `Configuration`
      Returns:
        The prefix of every script placeholder. (default: FP__ )

    - #### getPlaceholders

          public java.util.Map<java.lang.String,​java.lang.String> getPlaceholders()

      Description copied from interface: `Configuration`
      Retrieves the map of <placeholder, replacementValue> to apply to sql migration scripts.
      Specified by:
        `getPlaceholders` in interface `Configuration`
      Returns:
        The map of <placeholder, replacementValue> to apply to sql migration scripts.

    - #### getTarget

          public MigrationVersion getTarget()

      Description copied from interface: `Configuration`
      Gets the target version up to which Flyway should consider migrations. Migrations with a higher version number will be ignored. Special values:
      - `current`: Designates the current version of the schema
      - `latest`: The latest version of the schema, as defined by the migration with the highest version
      - `next`: The next version of the schema, as defined by the first pending migration
      - <version>? (end with a '?'): Instructs Flyway not to fail if the target version doesn't exist. In this case, Flyway will go up to but not beyond the specified target (default: fail if the target version doesn't exist) Flyway Teams only
      Specified by:
        `getTarget` in interface `Configuration`
      Returns:
        The target version up to which Flyway should consider migrations. Defaults to `latest`

    - #### isFailOnMissingTarget

          public boolean isFailOnMissingTarget()

      Description copied from interface: `Configuration`
      Whether to fail if no migration with the configured target version exists (default: `true`)
      Specified by:
        `isFailOnMissingTarget` in interface `Configuration`

    - #### getCherryPick

          public MigrationPattern[] getCherryPick()

      Description copied from interface: `Configuration`
      Gets the migrations that Flyway should consider when migrating or undoing. Leave empty to consider all available migrations. Migrations not in this list will be ignored. Flyway Teams only
      Specified by:
        `getCherryPick` in interface `Configuration`
      Returns:
        The migrations that Flyway should consider when migrating or undoing.

    - #### getTable

          public java.lang.String getTable()

      Description copied from interface: `Configuration`
      Retrieves the name of the schema history table that will be used by Flyway. By default, (single-schema mode) the schema history table is placed in the default schema for the connection provided by the datasource. When the flyway.schemas property is set (multi-schema mode), the schema history table is placed in the first schema of the list, or in the schema specified to flyway.defaultSchema.
      Specified by:
        `getTable` in interface `Configuration`
      Returns:
        The name of the schema history table that will be used by Flyway. (default: flyway_schema_history)

    - #### getTablespace

          public java.lang.String getTablespace()

      Description copied from interface: `Configuration`
      The tablespace where to create the schema history table that will be used by Flyway. If not specified, Flyway uses the default tablespace for the database connection. This setting is only relevant for databases that do support the notion of tablespace. Its value is simply ignored for all others.
      Specified by:
        `getTablespace` in interface `Configuration`
      Returns:
        The tablespace where to create the schema history table that will be used by Flyway.

    - #### setDryRunOutput

          public void setDryRunOutput​(java.io.OutputStream dryRunOutput)

      Sets the stream where to output the SQL statements of a migration dry run. `null` to execute the SQL statements directly against the database. The stream will be closed when Flyway finishes writing the output. Flyway Teams only
      Parameters:
        `dryRunOutput` - The output file or `null` to execute the SQL statements directly against the database.

    - #### setDryRunOutputAsFile

          public void setDryRunOutputAsFile​(java.io.File dryRunOutput)

      Sets the file where to output the SQL statements of a migration dry run. `null` to execute the SQL statements directly against the database. If the file specified is in a non-existent directory, Flyway will create all directories and parent directories as needed. Flyway Teams only
      Parameters:
        `dryRunOutput` - The output file or `null` to execute the SQL statements directly against the database.

    - #### setDryRunOutputAsFileName

          public void setDryRunOutputAsFileName​(java.lang.String dryRunOutputFileName)

      Sets the file where to output the SQL statements of a migration dry run. `null` to execute the SQL statements directly against the database. If the file specified is in a non-existent directory, Flyway will create all directories and parent directories as needed. Paths starting with s3: point to a bucket in AWS S3, which must exist. They are in the format s3:(/optionalfolder/subfolder)/filename.sql Paths starting with gcs: point to a bucket in Google Cloud Storage, which must exist. They are in the format gcs:(/optionalfolder/subfolder)/filename.sql Flyway Teams only
      Parameters:
        `dryRunOutputFileName` - The name of the output file or `null` to execute the SQL statements directly against the database.

    - #### setErrorOverrides

          public void setErrorOverrides​(java.lang.String... errorOverrides)

      Rules for the built-in error handler that let you override specific SQL states and errors codes in order to force specific errors or warnings to be treated as debug messages, info messages, warnings or errors.

      Each error override has the following format: `STATE:12345:W`. It is a 5 character SQL state (or * to match all SQL states), a colon, the SQL error code (or * to match all SQL error codes), a colon and finally the desired behavior that should override the initial one.

      The following behaviors are accepted:

      - `D` to force a debug message
      - `D-` to force a debug message, but do not show the original sql state and error code
      - `I` to force an info message
      - `I-` to force an info message, but do not show the original sql state and error code
      - `W` to force a warning
      - `W-` to force a warning, but do not show the original sql state and error code
      - `E` to force an error
      - `E-` to force an error, but do not show the original sql state and error code

      Example 1: to force Oracle stored procedure compilation issues to produce errors instead of warnings, the following errorOverride can be used: `99999:17110:E`

      Example 2: to force SQL Server PRINT messages to be displayed as info messages (without SQL state and error code details) instead of warnings, the following errorOverride can be used: `S0001:0:I-`

      Example 3: to force all errors with SQL error code 123 to be treated as warnings instead, the following errorOverride can be used: `*:123:W`

      Flyway Teams only
      Parameters:
        `errorOverrides` - The ErrorOverrides or an empty array if none are defined. (default: none)

    - #### setInstalledBy

          public void setInstalledBy​(java.lang.String installedBy)

      The username that will be recorded in the schema history table as having applied the migration.
      Parameters:
        `installedBy` - The username or `null` for the current database user of the connection. (default: `null`).

    - #### setLoggers

          public void setLoggers​(java.lang.String... loggers)

      The loggers Flyway should use. Valid options are:
      - auto: Auto detect the logger (default behavior)
      - console: Use stdout/stderr (only available when using the CLI)
      - slf4j2: Use the slf4j2 logger
      - log4j2: Use the log4j2 logger
      - apache-commons: Use the Apache Commons logger
      Alternatively you can provide the fully qualified class name for any other logger to use that.

    - #### setIgnoreMigrationPatterns

          public void setIgnoreMigrationPatterns​(java.lang.String... ignoreMigrationPatterns)

      Ignore migrations that match this comma-separated list of patterns when validating migrations. Each pattern is of the form : See https://flywaydb.org/documentation/configuration/parameters/ignoreMigrationPatterns for full details Example: repeatable:missing,versioned:pending,*:failed Flyway Teams only

    - #### setIgnoreMigrationPatterns

          public void setIgnoreMigrationPatterns​(ValidatePattern... ignoreMigrationPatterns)

      Ignore migrations that match this array of ValidatePatterns when validating migrations. See https://flywaydb.org/documentation/configuration/parameters/ignoreMigrationPatterns for full details Flyway Teams only

    - #### setLocationsAsStrings

          public void setLocationsAsStrings​(java.lang.String... locations)

      Sets the locations to scan recursively for migrations. The location type is determined by its prefix. Unprefixed locations or locations starting with `classpath:` point to a package on the classpath and may contain both SQL and Java-based migrations. Locations starting with `filesystem:` point to a directory on the filesystem, may only contain SQL migrations and are only scanned recursively down non-hidden directories.
      Parameters:
        `locations` - Locations to scan recursively for migrations. (default: db/migration)

    - #### setLocations

          public void setLocations​(Location... locations)

      Sets the locations to scan recursively for migrations. The location type is determined by its prefix. Unprefixed locations or locations starting with `classpath:` point to a package on the classpath and may contain both SQL and Java-based migrations. Locations starting with `filesystem:` point to a directory on the filesystem, may only contain SQL migrations and are only scanned recursively down non-hidden directories.
      Parameters:
        `locations` - Locations to scan recursively for migrations. (default: db/migration)

    - #### setDetectEncoding

          public void setDetectEncoding​(boolean detectEncoding)

      Whether Flyway should try to automatically detect SQL migration file encoding
      Parameters:
        `detectEncoding` - `true` to enable auto detection, `false` otherwise Flyway Teams only

    - #### setExecuteInTransaction

          public void setExecuteInTransaction​(boolean executeInTransaction)

      Sets whether SQL should be executed within a transaction.
      Parameters:
        `executeInTransaction` - `true` to enable execution of SQL in a transaction, `false` otherwise

    - #### setEncodingAsString

          public void setEncodingAsString​(java.lang.String encoding)

      Sets the encoding of SQL migrations.
      Parameters:
        `encoding` - The encoding of SQL migrations. (default: UTF-8)

    - #### setTargetAsString

          public void setTargetAsString​(java.lang.String target)

      Sets the target version up to which Flyway should consider migrations. Migrations with a higher version number will be ignored. Special values:
      - `current`: Designates the current version of the schema
      - `latest`: The latest version of the schema, as defined by the migration with the highest version
      - `next`: The next version of the schema, as defined by the first pending migration
      - <version>? (end with a '?'): Instructs Flyway not to fail if the target version doesn't exist. In this case, Flyway will go up to but not beyond the specified target (default: fail if the target version doesn't exist) Flyway Teams only
      Defaults to `latest`.

    - #### setCherryPick

          public void setCherryPick​(MigrationPattern... cherryPick)

      Gets the migrations that Flyway should consider when migrating or undoing. Leave empty to consider all available migrations. Migrations not in this list will be ignored. Flyway Teams only

    - #### setCherryPick

          public void setCherryPick​(java.lang.String... cherryPickAsString)

      Gets the migrations that Flyway should consider when migrating or undoing. Leave empty to consider all available migrations. Migrations not in this list will be ignored. Values should be the version for versioned migrations (e.g. 1, 2.4, 6.5.3) or the description for repeatable migrations (e.g. Insert_Data, Create_Table) Flyway Teams only

    - #### setPlaceholderPrefix

          public void setPlaceholderPrefix​(java.lang.String placeholderPrefix)

      Sets the prefix of every placeholder.
      Parameters:
        `placeholderPrefix` - The prefix of every placeholder. (default: ${ )

    - #### setScriptPlaceholderPrefix

          public void setScriptPlaceholderPrefix​(java.lang.String scriptPlaceholderPrefix)

      Sets the prefix of every script placeholder.
      Parameters:
        `scriptPlaceholderPrefix` - The prefix of every placeholder. (default: FP__ )

    - #### setPlaceholderSuffix

          public void setPlaceholderSuffix​(java.lang.String placeholderSuffix)

      Sets the suffix of every placeholder.
      Parameters:
        `placeholderSuffix` - The suffix of every placeholder. (default: } )

    - #### setPlaceholderSeparator

          public void setPlaceholderSeparator​(java.lang.String placeholderSeparator)

      Sets the separator of default placeholders.
      Parameters:
        `placeholderSeparator` - The separator of default placeholders. (default: : )

    - #### setScriptPlaceholderSuffix

          public void setScriptPlaceholderSuffix​(java.lang.String scriptPlaceholderSuffix)

      Sets the suffix of every placeholder.
      Parameters:
        `scriptPlaceholderSuffix` - The suffix of every placeholder. (default: __ )

    - #### setSqlMigrationPrefix

          public void setSqlMigrationPrefix​(java.lang.String sqlMigrationPrefix)

      Sets the file name prefix for sql migrations. SQL migrations have the following file name structure: prefixVERSIONseparatorDESCRIPTIONsuffix, which using the defaults translates to V1_1__My_description.sql
      Parameters:
        `sqlMigrationPrefix` - The file name prefix for sql migrations (default: V)

    - #### setUndoSqlMigrationPrefix

          public void setUndoSqlMigrationPrefix​(java.lang.String undoSqlMigrationPrefix)

      Sets the file name prefix for undo SQL migrations. (default: U) Undo SQL migrations are responsible for undoing the effects of the versioned migration with the same version. They have the following file name structure: prefixVERSIONseparatorDESCRIPTIONsuffix, which using the defaults translates to U1.1__My_description.sql <Flyway Teams only
      Parameters:
        `undoSqlMigrationPrefix` - The file name prefix for undo SQL migrations. (default: U)

    - #### setJavaMigrations

          public void setJavaMigrations​(JavaMigration... javaMigrations)

      The manually added Java-based migrations. These are not Java-based migrations discovered through classpath scanning and instantiated by Flyway. Instead these are manually added instances of JavaMigration. This is particularly useful when working with a dependency injection container, where you may want the DI container to instantiate the class and wire up its dependencies for you.
      Parameters:
        `javaMigrations` - The manually added Java-based migrations. An empty array if none. (default: none)

    - #### setStream

          public void setStream​(boolean stream)

      Whether to stream SQL migrations when executing them. Streaming doesn't load the entire migration in memory at once. Instead each statement is loaded individually. This is particularly useful for very large SQL migrations composed of multiple MB or even GB of reference data, as this dramatically reduces Flyway's memory consumption. Flyway Teams only
      Parameters:
        `stream` - `true` to stream SQL migrations. `false` to fully loaded them in memory instead. (default: `false`)

    - #### setBatch

          public void setBatch​(boolean batch)

      Whether to batch SQL statements when executing them. Batching can save up to 99 percent of network roundtrips by sending up to 100 statements at once over the network to the database, instead of sending each statement individually. This is particularly useful for very large SQL migrations composed of multiple MB or even GB of reference data, as this can dramatically reduce the network overhead. This is supported for INSERT, UPDATE, DELETE, MERGE and UPSERT statements. All other statements are automatically executed without batching. Flyway Teams only
      Parameters:
        `batch` - `true` to batch SQL statements. `false` to execute them individually instead. (default: `false`)

    - #### setSqlMigrationSeparator

          public void setSqlMigrationSeparator​(java.lang.String sqlMigrationSeparator)

      Sets the file name separator for sql migrations. SQL migrations have the following file name structure: prefixVERSIONseparatorDESCRIPTIONsuffix, which using the defaults translates to V1_1__My_description.sql
      Parameters:
        `sqlMigrationSeparator` - The file name separator for sql migrations (default: __)

    - #### setSqlMigrationSuffixes

          public void setSqlMigrationSuffixes​(java.lang.String... sqlMigrationSuffixes)

      The file name suffixes for SQL migrations. (default: .sql) SQL migrations have the following file name structure: prefixVERSIONseparatorDESCRIPTIONsuffix, which using the defaults translates to V1_1__My_description.sql Multiple suffixes (like .sql,.pkg,.pkb) can be specified for easier compatibility with other tools such as editors with specific file associations.
      Parameters:
        `sqlMigrationSuffixes` - The file name suffixes for SQL migrations.

    - #### setDataSource

          public void setDataSource​(javax.sql.DataSource dataSource)

      Sets the datasource to use. Must have the necessary privileges to execute DDL.
      Parameters:
        `dataSource` - The datasource to use. Must have the necessary privileges to execute DDL.

    - #### setDataSource

          public void setDataSource​(java.lang.String url,
                                    java.lang.String user,
                                    java.lang.String password)

      Sets the datasource to use. Must have the necessary privileges to execute DDL. To use a custom ClassLoader, setClassLoader() must be called prior to calling this method.
      Parameters:
        `url` - The JDBC URL of the database.
        `user` - The user of the database.
        `password` - The password of the database.

    - #### setConnectRetries

          public void setConnectRetries​(int connectRetries)

      The maximum number of retries when attempting to connect to the database. After each failed attempt, Flyway will wait 1 second before attempting to connect again, up to the maximum number of times specified by connectRetries. The interval between retries doubles with each subsequent attempt.
      Parameters:
        `connectRetries` - The maximum number of retries (default: 0).

    - #### setConnectRetriesInterval

          public void setConnectRetriesInterval​(int connectRetriesInterval)

      The maximum time between retries when attempting to connect to the database in seconds. This will cap the interval between connect retry to the value provided.
      Parameters:
        `connectRetriesInterval` - The maximum time between retries in seconds (default: 120).

    - #### setBaselineVersionAsString

          public void setBaselineVersionAsString​(java.lang.String baselineVersion)

      Sets the version to tag an existing schema with when executing baseline.
      Parameters:
        `baselineVersion` - The version to tag an existing schema with when executing baseline. (default: 1)

    - #### setSkipExecutingMigrations

          public void setSkipExecutingMigrations​(boolean skipExecutingMigrations)

      Whether Flyway should skip actually executing the contents of the migrations and only update the schema history table. This should be used when you have applied a migration manually (via executing the sql yourself, or via an IDE), and just want the schema history table to reflect this. Use in conjunction with `cherryPick` to skip specific migrations instead of all pending ones. Flyway Teams only

    - #### setCallbacks

          public void setCallbacks​(Callback... callbacks)

    - #### setCallbacksAsClassNames

          public void setCallbacksAsClassNames​(java.lang.String... callbacks)

      Set the callbacks for lifecycle notifications.
      Parameters:
        `callbacks` - The fully qualified class names, or full qualified package to scan, of the callbacks for lifecycle notifications. (default: none)

    - #### loadCallbackLocation

          public java.util.List<Callback> loadCallbackLocation​(java.lang.String path,
                                                               boolean errorOnNotFound)

      Scan this location for classes that implement Callback.
      Parameters:
        `path` - The path to scan.
        `errorOnNotFound` - Whether to show an error if the location is not found.

    - #### setResolvers

          public void setResolvers​(MigrationResolver... resolvers)

      Sets custom MigrationResolvers to be used in addition to the built-in ones for resolving Migrations to apply.
      Parameters:
        `resolvers` - The custom MigrationResolvers to be used in addition to the built-in ones for resolving Migrations to apply. (default: empty list)

    - #### setResolversAsClassNames

          public void setResolversAsClassNames​(java.lang.String... resolvers)

      Sets custom MigrationResolvers to be used in addition to the built-in ones for resolving Migrations to apply.
      Parameters:
        `resolvers` - The fully qualified class names of the custom MigrationResolvers to be used in addition to the built-in ones for resolving Migrations to apply. (default: empty list)

    - #### setOracleSqlplus

          public void setOracleSqlplus​(boolean oracleSqlplus)

      Whether Flyway's support for Oracle SQL*Plus commands should be activated. Flyway Teams only
      Parameters:
        `oracleSqlplus` - `true` to active SQL*Plus support. `false` to fail fast instead. (default: `false`)

    - #### setOracleSqlplusWarn

          public void setOracleSqlplusWarn​(boolean oracleSqlplusWarn)

      Whether Flyway should issue a warning instead of an error whenever it encounters an Oracle SQL*Plus statementit doesn't yet support. Flyway Teams only
      Parameters:
        `oracleSqlplusWarn` - `true` to issue a warning. `false` to fail fast instead. (default: `false`)

    - #### setOracleKerberosCacheFile

          public void setOracleKerberosCacheFile​(java.lang.String oracleKerberosCacheFile)

      When Oracle needs to connect to a Kerberos service to authenticate, the location of the Kerberos cache. Flyway Teams only

    - #### setKerberosConfigFile

          public void setKerberosConfigFile​(java.lang.String kerberosConfigFile)

      When connecting to a Kerberos service to authenticate, the path to the Kerberos config file. Flyway Teams only

    - #### setOracleWalletLocation

          public void setOracleWalletLocation​(java.lang.String oracleWalletLocation)

      The location of your Oracle wallet, used to automatically sign in to your databases. Flyway Teams only
      Parameters:
        `oracleWalletLocation` - The path to your Oracle Wallet

    - #### setShouldCreateSchemas

          public void setShouldCreateSchemas​(boolean createSchemas)

      Whether Flyway should attempt to create the schemas specified in the schemas property.
      Parameters:
        `createSchemas` -

    - #### setLicenseKey

          public void setLicenseKey​(java.lang.String licenseKey)

      Your Flyway license key (FL01...). Not yet a Flyway Teams Edition customer? Request your Flyway trial license key to try out Flyway Teams Edition features free for 30 days. Flyway Teams only

    - #### setOutputQueryResults

          public void setOutputQueryResults​(boolean outputQueryResults)

      Whether Flyway should output a table with the results of queries when executing migrations. Flyway Teams only

    - #### setJdbcProperties

          public void setJdbcProperties​(java.util.Map<java.lang.String,​java.lang.String> jdbcProperties)

      Properties to pass to the JDBC driver object. Flyway Teams only

    - #### configure

          public void configure​(Configuration configuration)

      Configure with the same values as this existing configuration.

    - #### configure

          public void configure​(java.util.Properties properties)

      Configures Flyway with these properties. This overwrites any existing configuration. Properties are documented here: https://flywaydb.org/documentation/configuration/parameters/

      To use a custom ClassLoader, setClassLoader() must be called prior to calling this method.

      Parameters:
        `properties` - Properties used for configuration.
      Throws:
        `FlywayException` - when the configuration failed.

    - #### setUrl

          public void setUrl​(java.lang.String url)

    - #### setUser

          public void setUser​(java.lang.String user)

    - #### setPassword

          public void setPassword​(java.lang.String password)

    - #### setDriver

          public void setDriver​(java.lang.String driver)

    - #### configure

          public void configure​(java.util.Map<java.lang.String,​java.lang.String> props)

      Configures Flyway with these properties. This overwrites any existing configuration. Properties are documented here: https://flywaydb.org/documentation/configuration/parameters/

      To use a custom ClassLoader, it must be passed to the Flyway constructor prior to calling this method.

      Parameters:
        `props` - Properties used for configuration.
      Throws:
        `FlywayException` - when the configuration failed.

    - #### setFailOnMissingLocations

          public void setFailOnMissingLocations​(java.lang.Boolean failOnMissingLocationsProp)

    - #### getDriver

          public java.lang.String getDriver()

    - #### setGroup

          public void setGroup​(java.lang.Boolean groupProp)

    - #### setMixed

          public void setMixed​(java.lang.Boolean mixedProp)

    - #### setEncoding

          public void setEncoding​(java.nio.charset.Charset encoding)

    - #### setPlaceholders

          public void setPlaceholders​(java.util.Map<java.lang.String,​java.lang.String> placeholdersFromProps)

    - #### setSkipDefaultCallbacks

          public void setSkipDefaultCallbacks​(java.lang.Boolean skipDefaultCallbacksProp)

    - #### setSkipDefaultResolvers

          public void setSkipDefaultResolvers​(java.lang.Boolean skipDefaultResolversProp)

    - #### setOutOfOrder

          public void setOutOfOrder​(java.lang.Boolean outOfOrderProp)

    - #### setLockRetryCount

          public void setLockRetryCount​(java.lang.Integer lockRetryCount)

    - #### setValidateMigrationNaming

          public void setValidateMigrationNaming​(java.lang.Boolean validateMigrationNamingProp)

    - #### setBaselineOnMigrate

          public void setBaselineOnMigrate​(java.lang.Boolean baselineOnMigrateProp)

    - #### setBaselineDescription

          public void setBaselineDescription​(java.lang.String baselineDescriptionProp)

    - #### setBaselineVersion

          public void setBaselineVersion​(java.lang.String baselineVersionProp)

    - #### setValidateOnMigrate

          public void setValidateOnMigrate​(java.lang.Boolean validateOnMigrateProp)

    - #### setCleanDisabled

          public void setCleanDisabled​(java.lang.Boolean cleanDisabledProp)

    - #### setCleanOnValidationError

          public void setCleanOnValidationError​(java.lang.Boolean cleanOnValidationErrorProp)

    - #### setTablespace

          public void setTablespace​(java.lang.String tablespaceProp)

    - #### setTable

          public void setTable​(java.lang.String tableProp)

    - #### setSchemas

          public void setSchemas​(java.lang.String[] tokenizeToStringArray)

    - #### setRepeatableSqlMigrationPrefix

          public void setRepeatableSqlMigrationPrefix​(java.lang.String repeatableSqlMigrationPrefixProp)

    - #### setPlaceholderReplacement

          public void setPlaceholderReplacement​(java.lang.Boolean placeholderReplacementProp)

    - #### setInitSql

          public void setInitSql​(java.lang.String initSqlProp)

    - #### configureUsingEnvVars

          public void configureUsingEnvVars()

      Configures Flyway using FLYWAY_* environment variables.

    - #### setTarget

          public void setTarget​(MigrationVersion target)

    - #### getModernConfig

          public org.flywaydb.core.internal.configuration.models.ConfigurationModel getModernConfig()

      Specified by:
        `getModernConfig` in interface `Configuration`

    - #### setModernConfig

          public void setModernConfig​(org.flywaydb.core.internal.configuration.models.ConfigurationModel modernConfig)

    - #### getResolvedEnvironments

          public java.util.Map<java.lang.String,​org.flywaydb.core.internal.configuration.models.ResolvedEnvironment> getResolvedEnvironments()

    - #### getDataSource

          public javax.sql.DataSource getDataSource()

      Description copied from interface: `Configuration`
      Retrieves the dataSource to use to access the database. Must have the necessary privileges to execute DDL.
      Specified by:
        `getDataSource` in interface `Configuration`
      Returns:
        The dataSource to use to access the database. Must have the necessary privileges to execute DDL.

    - #### getClassLoader

          public java.lang.ClassLoader getClassLoader()

      Description copied from interface: `Configuration`
      Retrieves the ClassLoader to use for loading migrations, resolvers, etc. from the classpath.
      Specified by:
        `getClassLoader` in interface `Configuration`
      Returns:
        The ClassLoader to use for loading migrations, resolvers, etc. from the classpath. (default: Thread.currentThread().getContextClassLoader() )

    - #### setClassLoader

          public void setClassLoader​(java.lang.ClassLoader classLoader)

    - #### getResourceProvider

          public ResourceProvider getResourceProvider()

      Description copied from interface: `Configuration`
      Retrieves the custom ResourceProvider to be used to look up resources. If not set, the default strategy will be used.
      Specified by:
        `getResourceProvider` in interface `Configuration`
      Returns:
        The custom ResourceProvider to be used to look up resources (default: null)

    - #### setResourceProvider

          public void setResourceProvider​(ResourceProvider resourceProvider)

    - #### getJavaMigrationClassProvider

          public ClassProvider<JavaMigration> getJavaMigrationClassProvider()

      Description copied from interface: `Configuration`
      Retrieves the custom ClassProvider to be used to look up `JavaMigration` classes. If not set, the default strategy will be used.
      Specified by:
        `getJavaMigrationClassProvider` in interface `Configuration`
      Returns:
        The custom ClassProvider to be used to look up `JavaMigration` classes (default: null)

    - #### setJavaMigrationClassProvider

          public void setJavaMigrationClassProvider​(ClassProvider<JavaMigration> javaMigrationClassProvider)

    - #### getJavaMigrations

          public JavaMigration[] getJavaMigrations()

      Description copied from interface: `Configuration`
      The manually added Java-based migrations. These are not Java-based migrations discovered through classpath scanning and instantiated by Flyway. Instead these are manually added instances of JavaMigration. This is particularly useful when working with a dependency injection container, where you may want the DI container to instantiate the class and wire up its dependencies for you.
      Specified by:
        `getJavaMigrations` in interface `Configuration`
      Returns:
        The manually added Java-based migrations. An empty array if none. (default: none)

    - #### getPluginRegister

          public org.flywaydb.core.internal.plugin.PluginRegister getPluginRegister()

      Specified by:
        `getPluginRegister` in interface `Configuration`

    - #### setPluginRegister

          public void setPluginRegister​(org.flywaydb.core.internal.plugin.PluginRegister pluginRegister)